#include "Preprocessor.h"
#include "SamplingPreprocessor.h"
#include "ExactPreprocessor.h"

namespace GtpVisibilityPreprocessor {

  bool
  Preprocessor::LoadViewcells(const string filename)
  {

    return true;
  }

  bool
  Preprocessor::GenerateViewcells()
  {
    
    return true;
  }
    
  bool
  Preprocessor::LoadScene(const string filename)
  {
    // use leaf nodes of the original spatial hiearrchy as occludees
    
    return true;
  }

  bool
  Preprocessor::ExportPreprocessedData(const string filename)
  {
    return false;
  }
  
  bool
  Preprocessor::BuildKdTree()
  {
    mKdTree = new KdTree;
    mKdTree->Subdivide(mKdTree->GetRoot());
    return true;
  }
  
};

int
main(int argc, char **argv)
{
  GtpVisibilityPreprocessor::Preprocessor *p = new GtpVisibilityPreprocessor::SamplingPreprocessor();
  p->LoadScene("scene.wrl");
  p->LoadViewcells("viewcells.wrl");
  p->ComputeVisibility();
  p->ExportPreprocessedData("scene.vis");
  return 0;
}
